﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Threading;

namespace RadBusyIndicator
{
	public partial class MainPage : UserControl
	{
		private object fe;
		private BackgroundWorker worker = new BackgroundWorker();
		private DispatcherTimer timer = new DispatcherTimer();

		public MainPage()
		{
			InitializeComponent();

			this.worker.DoWork += this.WorkerDoWork;
			this.worker.RunWorkerCompleted += WorkerRunWorkerCompleted;
		}

		private void TextBox_LostFocus(object sender, RoutedEventArgs e)
		{
			if (!this.worker.IsBusy)
			{
				this.RadBusyIndicator.IsBusy = true;
				this.fe = FocusManager.GetFocusedElement();
				this.worker.RunWorkerAsync();
			}
		}

		private void WorkerDoWork(object sender, DoWorkEventArgs e)
		{
			System.Threading.Thread.Sleep(2000);
		}

		private void WorkerRunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
		{
			this.RadBusyIndicator.IsBusy = false;
			timer.Interval = new TimeSpan(5000000);
			timer.Tick += 
			delegate(object s, EventArgs args) 
			{
				var focusedElement = (Control)fe;
				focusedElement.Focus();
			};
			timer.Start();
		}
	}
}
